/*
 * Copyright COCKTAIL (www.cocktail.org), 1995, 2012 This software 
 * is governed by the CeCILL license under French law and abiding by the
 * rules of distribution of free software. You can use, modify and/or 
 * redistribute the software under the terms of the CeCILL license as 
 * circulated by CEA, CNRS and INRIA at the following URL 
 * "http://www.cecill.info". 
 * As a counterpart to the access to the source code and rights to copy, modify 
 * and redistribute granted by the license, users are provided only with a 
 * limited warranty and the software's author, the holder of the economic 
 * rights, and the successive licensors have only limited liability. In this 
 * respect, the user's attention is drawn to the risks associated with loading,
 * using, modifying and/or developing or reproducing the software by the user 
 * in light of its specific status of free software, that may mean that it
 * is complicated to manipulate, and that also therefore means that it is 
 * reserved for developers and experienced professionals having in-depth
 * computer knowledge. Users are therefore encouraged to load and test the 
 * software's suitability as regards their requirements in conditions enabling
 * the security of their systems and/or data to be ensured and, more generally, 
 * to use and operate it in the same conditions as regards security. The
 * fact that you are presently reading this means that you have had knowledge 
 * of the CeCILL license and that you accept its terms.
 */
package org.cocktail.carambole.server.components;

// Generated by the WOLips Templateengine Plug-in at 4 sept. 2007 15:35:43

import org.cocktail.carambole.server.MyAjaxPage;
import org.cocktail.fwkcktldepense.server.finder.FinderDepensePapier;
import org.cocktail.fwkcktldepense.server.metier.EOCommande;
import org.cocktail.fwkcktldepense.server.metier.EOCommandeEngagement;
import org.cocktail.fwkcktldepense.server.metier.EODepensePapier;
import org.cocktail.fwkcktldepense.server.metier.EOEngagementBudget;
import org.cocktail.fwkcktldepense.server.metier.EOEngagementControleAction;
import org.cocktail.fwkcktldepense.server.metier.EOEngagementControleAnalytique;
import org.cocktail.fwkcktldepense.server.metier.EOEngagementControleConvention;
import org.cocktail.fwkcktldepense.server.metier.EOEngagementControleHorsMarche;
import org.cocktail.fwkcktldepense.server.metier.EOEngagementControleMarche;
import org.cocktail.fwkcktldepense.server.metier.EOEngagementControlePlanComptable;
import org.cocktail.fwkcktlpersonne.common.metier.EOFournis;

import com.webobjects.appserver.WOComponent;
import com.webobjects.appserver.WOContext;
import com.webobjects.appserver.WOResponse;
import com.webobjects.eocontrol.EOEditingContext;
import com.webobjects.foundation.NSArray;
import com.webobjects.foundation.NSMutableDictionary;

import er.extensions.eof.ERXEC;

public class DetailEngagementBudget extends MyAjaxPage {
	private static final String PAGE_TITLE = "Détail d'un engagement";
	private static final long serialVersionUID = 1L;

	public EOEngagementBudget engagementBudget = null;

	public EOCommandeEngagement unEngagement = null;
	public EOEngagementControleHorsMarche unEngagementControleHorsMarche = null;
	public EOEngagementControleAction unEngagementControleAction = null;
	public EOEngagementControlePlanComptable unEngagementControlePlanCo = null;
	public EOEngagementControleConvention unEngagementControleConvention = null;
	public EOEngagementControleAnalytique unEngagementControleAnalytique = null;

	private EODepensePapier selectedDepensePapier;

	public DetailEngagementBudget(WOContext context) {
		super(context);
	}

	public EOEngagementBudget getEngagementBudget() {
		return engagementBudget;
	}

	public void setEngagementBudget(EOEngagementBudget engagementBudget) {
		this.engagementBudget = engagementBudget;
	}

	public NSArray<String> itemsMenu() {
		NSArray<String> items = new NSArray<String>(new String[] {
				"AfficherCommandeDetaillee",
				"SupprimerUnEngagement",
				"Accueil",
				"RetourALaListe"
		});
		return items;
	}

	public void appendToResponse(WOResponse res, WOContext ctx) {
		super.appendToResponse(res, ctx);
	}

	public boolean isAfficherRepartCN() {
		boolean isAfficherRepartCN = true;
		EOEngagementBudget engagement = getEngagementBudget();
		if (engagement != null) {
			if (engagement.isSurUnMarche()) {
				isAfficherRepartCN = false;
			}
		}
		return isAfficherRepartCN;
	}

	public WOComponent afficherDetailCommande() {
		DetailCommande nextPage = (DetailCommande) pageWithName("DetailCommande");

		EOCommande commande = getEngagementBudget().commande();
		nextPage.setLaCommande(commande);

		return nextPage;
	}

	public WOComponent afficherDetailFacture() {
		DetailFacture nextPage = (DetailFacture) pageWithName("DetailFacture");
		EODepensePapier dp = getSelectedDepensePapier();
		EOEditingContext newEdc = ERXEC.newEditingContext();
		dp = (EODepensePapier) newEdc.faultForGlobalID(dp.editingContext().globalIDForObject(dp), newEdc);
		nextPage.setLaFacture(dp);
		session.setLaDepensePapierEnCours(dp);
		session.setLaCommandeEnCours(dp.commandeassociee());
		return nextPage;
	}

	public NSArray<EODepensePapier> getLesDepensesPapier() {
		NSArray<EODepensePapier> lesDepensesPapier = null;
		EOEngagementBudget engagement = getEngagementBudget();
		if (engagement != null && lesDepensesPapier == null) {
			NSMutableDictionary<String, Object> bindings = new NSMutableDictionary<String, Object>();
			bindings.setObjectForKey(engagement, "engagement");
			lesDepensesPapier = FinderDepensePapier.getDepensePapier(engagement.editingContext(), bindings);
		}
		return lesDepensesPapier;
	}

	public EOEngagementControleAction getUnEngagementControleAction() {
		return unEngagementControleAction;
	}

	public void setUnEngagementControleAction(
			EOEngagementControleAction unEngagementControleAction) {
		this.unEngagementControleAction = unEngagementControleAction;
	}

	public EOEngagementControleAnalytique getUnEngagementControleAnalytique() {
		return unEngagementControleAnalytique;
	}

	public void setUnEngagementControleAnalytique(
			EOEngagementControleAnalytique unEngagementControleAnalytique) {
		this.unEngagementControleAnalytique = unEngagementControleAnalytique;
	}

	public EOEngagementControleConvention getUnEngagementControleConvention() {
		return unEngagementControleConvention;
	}

	public void setUnEngagementControleConvention(
			EOEngagementControleConvention unEngagementControleConvention) {
		this.unEngagementControleConvention = unEngagementControleConvention;
	}

	public EOEngagementControleHorsMarche getUnEngagementControleHorsMarche() {
		return unEngagementControleHorsMarche;
	}

	public void setUnEngagementControleHorsMarche(
			EOEngagementControleHorsMarche unEngagementControleHorsMarche) {
		this.unEngagementControleHorsMarche = unEngagementControleHorsMarche;
	}

	public EOEngagementControlePlanComptable getUnEngagementControlePlanCo() {
		return unEngagementControlePlanCo;
	}

	public void setUnEngagementControlePlanCo(
			EOEngagementControlePlanComptable unEngagementControlePlanCo) {
		this.unEngagementControlePlanCo = unEngagementControlePlanCo;
	}

	public String pageTitle() {
		return PAGE_TITLE;
	}

	public EOFournis getFournis() {
		if (getEngagementBudget() == null) {
			return null;
		}
		EOFournis fournis = EOFournis.fetchByKeyValue(getEngagementBudget().fournisseur().editingContext(), EOFournis.FOU_ORDRE_KEY, getEngagementBudget().fournisseur().fouOrdre());
		return fournis;
	}

	public EODepensePapier getSelectedDepensePapier() {
		return selectedDepensePapier;
	}

	public void setSelectedDepensePapier(EODepensePapier selectedDepensePapier) {
		this.selectedDepensePapier = selectedDepensePapier;
	}

	public String getStyleForSourceType() {
		return SourcesComponentsHelper.getStyleForSourceType(getEngagementBudget());
	}

	public EOEngagementControleMarche getEngageCtrlMarcheUnique() {
		if (getEngagementBudget() != null && getEngagementBudget().engagementControleMarches() != null && getEngagementBudget().engagementControleMarches().count() == 1) {
			return getEngagementBudget().engagementControleMarches().objectAtIndex(0);
		}
		return null;
	}
}